'''
Created on 5 june 2018

@author: Steven Fletcher - INRIA - Institut Pasteur - InBio
'''
from copy import deepcopy

class Frame():
    '''this object contains all the information pertaining to the data generated by the experiment'''
    def __init__(self, MANAGER, positions_list, protocol):
        '''Args:
        MANAGER(multiprocessing.Manager instance): the instance of the multiprocessing.Manager() insatnce to creat new inter process objects
        positions_list(list): list of positions object
        protocol(Protocol object): the protocol object attached to this image
        '''
        self.list_images = MANAGER.list([Image(position=positions_list[_], cell_population=[], track_table=None, protocol=protocol) for _ in range(len(positions_list))])

    def add_image(self, position_index, image):
        '''this simple function adds a new Image object to the list of images
        Args:
            position_index(int): # of the postion
            image(object): an instance of the image object to add to the list
        '''
        self.list_images[position_index] = image

    def update_image(self, position, protocol, track_table, cell_population, average_fluo=None, misc=None): #TODO: make dynamic?
        '''this method updates an existing image (useful after initialization)
        Args:
            position(object): the position object
            protocol(object): the protocol object attached to this image
            track_table(matrix): the matrix that is outputed by the meta tracker
            cell_population(list): list of Cell objects
            average_fluo(dict): key(str) is fluo name tag ; item(float) is the average fluorescence of the image for that channel
                - this value will be generated by a variety of functions
            protocol(Protocol object): the protocol object that contains the information related to the experiement Acquisition loop when Image was taken
            misc(str): a miscellaneous string
        '''
        image = self.list_images[position.index]
        image.position = position
        image.protocol = protocol
        image.average_fluo = average_fluo
        image.track_table = track_table
        image.cell_population = cell_population
        if image.cell_population:
            image.total_cell_pop = len(cell_population)
        image.misc = misc
        return image

    def __str__(self):
        '''prints the object according to a specified format
        '''
        if None not in self.list_images:
            return '{}'.format([image for image in self.list_images])


class Image():
    '''this object contains all the information pertaining to 1 image'''
    def __init__(self, position, cell_population, track_table, protocol, misc=None):
        '''Args:
        position(object): the Position object linked to the Image
            - This object is generated when reading the .pos file
        average_fluo(dict): key(str) is fluo name tag ; item(float) is the average fluorescence of the image for that channel
            - this value will be generated by a variety of functions
        cell_population(list of Cell objects): list of all the cells in the image
        track_table(array of arrays): a table that contains all the tracking information
        protocol(Protocol object): the protocol object that contains the information related to the experiement Acquisition loop when Image was taken
        misc(str)(optional): a miscellaneous string that can contain whatever the user whishes to put in
        '''
        self.position = deepcopy(position) #a copy of the Position tied to this image
        self.protocol = deepcopy(protocol) #a copy of the Protocol object when the image was taken
        self.average_fluo = {} #the average fluo of the image
        self.cell_population = cell_population #the list of Cell objects
        self.total_cell_pop = 0
        if self.cell_population:
            self.total_cell_pop = len(self.cell_population) #total # of cells in image
        self.track_table = track_table #the tracking table to link cells of previous image to these ones
        self.misc = misc #whatever you want to put in

class Cell():
    '''this object contains all the information pertaining to 1 cell'''
    def __init__(self, tracknumber, fluolevels, coordinates, misc='None'):
        '''Args:
            tracknumber(int): contains the tracking # associated with this cell -1 if cell is abscent (len #frames)
            fluolevels(dict): key is fluo name tag ; item is list of the fluolevels of key fluorophore -1 if cell is abscent(len #frames)
            coordinates(list of tuples): contains the list of coordinates (tuples) or -1 if cell is abscent
            misc(str): a miscellaneous string that can contain whatever the user whishes to put in
        '''
        self.tracknumber = tracknumber #the tracking # attachedto the cell
        self.fluolevels = fluolevels #the fluo levels of the different channels
        self.coordinates = coordinates #xy coordinates of the cell
        self.misc = misc #whatever you want
